package ovh.herisson.Clyde.EndPoints;


import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.*;
import ovh.herisson.Clyde.Responses.UnauthorizedResponse;
import ovh.herisson.Clyde.Services.AuthenticatorService;
import ovh.herisson.Clyde.Services.CursusCourseService;
import ovh.herisson.Clyde.Services.CursusService;
import ovh.herisson.Clyde.Tables.Cursus;
import ovh.herisson.Clyde.Tables.CursusCourse;
import ovh.herisson.Clyde.Tables.Role;
import ovh.herisson.Clyde.Tables.User;

import java.util.Map;

@RestController
public class CursusController {


    private final CursusService cursusServ;
    private final AuthenticatorService authServ;

    private final CursusCourseService cursusCourseServ;

    public CursusController(CursusService cursusServ, AuthenticatorService authServ, CursusCourseService cursusCourseServ){
        this.cursusServ = cursusServ;
        this.authServ = authServ;
        this.cursusCourseServ = cursusCourseServ;
    }

    @GetMapping("/cursus/{id}")
    public ResponseEntity<Cursus> findById(@PathVariable long id){
        return new ResponseEntity<>(cursusServ.findById(id), HttpStatus.OK);
    }

    @GetMapping("/curriculums")
    public ResponseEntity<Iterable<Map<String, Object>>> findAllindDepth(){
        return new ResponseEntity<>(cursusCourseServ.getAllDepthCursus(),HttpStatus.OK);
    }

    @GetMapping("/curriculum")
    public ResponseEntity<Iterable<CursusCourse>> findAll(){
        return new ResponseEntity<>(cursusCourseServ.findAll(),HttpStatus.OK);
    }

    /**@PostMapping("/cursus")
    public ResponseEntity<String> postCursus(@RequestHeader("Authorization") String token,@RequestBody Cursus cursus){

        if (!isSecretaryOrAdmin(token)){
            return new UnauthorizedResponse<>("you're not allowed to post a cursus");
        }

        cursusServ.save(cursus);

        return new ResponseEntity<>("created !",HttpStatus.CREATED);
    }**/



    private boolean isSecretaryOrAdmin(String authorization){
        if (authorization ==null)
            return false;

        User poster = authServ.getUserFromToken(authorization);
        if (poster == null) return false;

        return poster.getRole() == Role.Secretary && poster.getRole() == Role.Admin;
    }
}
